#!c:\perl\bin\perl.exe
print "Content-type: text/html\n\n";

##-------Config Starts Here-------##

## The local path to your media root directory. All its subfolders will be also be accessible.
my($rootdir) = "f:/mp3";

## The public path to your media root directory. DO NOT USE ESCAPED SYMBOLS IN THE URL.
my($remdir) = "http://10.0.0.35/mp3";

##-------Config  Ends  Here-------##

use URI::Escape;
use File::Util;
use CGI::Carp qw(fatalsToBrowser);
use strict;

local *urlsplit = sub {
	my %m = ();
	foreach my $i (split($_[0], $_[1])) {
		my ($k, $v) = (split(/=/, $i, 2));
		$k =~ y/+/ /; $v =~ y/+/ /;
		$k =~ s/\%([a-fA-F0-9]{2})/pack('C', hex($1))/seg;
		$v =~ s/\%([a-fA-F0-9]{2})/pack('C', hex($1))/seg;
		$m{$k} = $v;
	}
	return (%m);
};

print "<html>\n";
print "<head><title>Torch's Radio</title></head>\n";
print "<link href=\"content.css\" rel=\"stylesheet\" type=\"text/css\" />\n";
print "<body>\n";
print "<script language=\"JavaScript\">window.onload = parent.onLoadProc; window.onunload = parent.onUnLoadProc;</script>";
print "<map name=\"topmap\">\n";
print "<area shape=\"rect\" coords=\"139,10,157,29\" href=\"javascript:parent.stopRadio();\">\n";
print "<area shape=\"rect\" coords=\"166,9,187,30\" href=\"javascript:parent.soundEffect();var ret=window.open('http://www.google.com/');\">\n";
print "<area shape=\"rect\" coords=\"202,7,327,28\" href=\"javascript:parent.soundEffect();alert('MyRadio BETA - By Torch (Kurian Abraham)\\nStream audio & playlists from your PC\\nto your PSP via Internet or LAN');\">\n";
print "</map>\n";
print "<map name=\"rightmap\">\n";
print "<area shape=\"poly\" coords=\"16,98,12,111,21,111\" href=\"javascript:window.scrollBy(0,-200);\">\n";
print "<area shape=\"poly\" coords=\"16,129,21,118,12,118\" href=\"javascript:window.scrollBy(0,200);\">\n";
print "</map>\n";
print "<img id=\"btop\" src=\"top.png\" height=\"43\" width=\"480\" border=\"0\" usemap=\"#topmap\">\n";
print "<img id=\"bleft\" src=\"left.png\" height=\"204\" width=\"29\" border=\"0\">\n";
print "<img id=\"bright\" src=\"right.png\" height=\"204\" width=\"30\" border=\"0\" usemap=\"#rightmap\">\n";
print "<img id=\"bbottom\" src=\"bottom.png\" height=\"25\" width=\"480\" border=\"0\">\n";
print "<span id=\"sbar\"> </span>\n";
print "<img id=\"mute\" src=\"mute.png\" height=\"156\" width=\"157\" border=\"0\">\n";

my (%in);

%in = &urlsplit('[&;]', $ENV{QUERY_STRING}) if ($ENV{QUERY_STRING} ne "");

my($reldir) = (exists $in{'subdir'})?uri_unescape($in{'subdir'}):"/";

$reldir .= '/' if($reldir !~ /\/$/);
$reldir = '/'.$reldir if($reldir !~ /^\//);

while ($reldir =~ /\/\.\./)	{
	$reldir =~ s/\/\.\./\//g;
}
$reldir =~ s/\/\//\//g;
$reldir =~ s/\/\.\///g;

my($f) = File::Util->new();
$rootdir =~ s/\\/\//g;
$rootdir =~ s/\/$//;
my($path) = $rootdir.$reldir;
my($sreldir) = uri_escape($reldir);

my($lreldir) = $reldir;
$lreldir =~ s/^\///;
$lreldir =~ s/\/$//;
my(@levels) = split(/\//,$lreldir);
my($level);

my($tree) = "<a href=\"?subdir=%2F\">root</a>";
my($atree) = "/";

foreach $level(@levels)	{
	$atree .= $level."/";
	$atree = uri_escape($atree);
	$tree .= "/<a href=\"?subdir=$atree\">$level</a>";
}

print "Current directory is: <b>$tree</b><br><br>\n";

if (exists $in{'m3u'})	{
	&m3uparse;
}
else	{
	&dirindex;
}

END
{
	print "</body>\n";
	print "</html>";
}

##Generate a song list in m3u mode
sub m3uparse	{

my($m3u) = $rootdir.$reldir.$in{'m3u'};

open(M3U, $m3u) || &m3unotfound($m3u);
my(@list) = <M3U>;
close(M3U);
chomp(@list);

print "[Playlist Mode] <b>$in{'m3u'}</b><br><br>\n";
print "<b>Note :</b> Only compatible files inside the root folder structure are shown.<br><br>\n";

foreach my $line (@list)	{
	
	next if (($line =~ /^#/) || (($line !~ /^http:\/\//i) && ($line !~ /\.(?:mp3|aac)$/i)));
	$line =~ s/\\/\//g;
	
	my($sline);
	
	if ($line !~ /^http:\/\//i)	{
		
		if ($line =~ /^.:/)	{
			next if !($line =~ /^($rootdir)\//i);
			$line =~ s/^($rootdir)\///i;
		}
		$line =~ s/\/$//;
		$sline = "$remdir$reldir$line";
		$line = "/".$line;
		$line =~ /.*\/(.*)$/;
		$line = $1;
	}
	$sline = uri_escape($sline,"^A-Za-z0-9\-_.!~*():/");
	
	print "<a href=\"javascript:parent.tune(\'$sline\',1);\">$line</a><br>\n";
}

return;
}

##Generate a directory index in normal mode
sub dirindex	{

print "<center>";

for (my $i=ord('A'); $i<=ord('Z'); $i++)	{
	print "<span id=\"s".chr($i)."\" style=\"color: #5a5a5a;\">|</span><a href=\"#".chr($i)."\" id=\"a".chr($i)."\">".chr($i)."</a>";
}

print "<span style=\"color: #5a5a5a;\">|</span></center><br>\n";

my(@dirs) = $f->list_dir($path, "--dirs-only", "--no-fsdots", "--ignore-case");
my($dir);

print "<b>Folders :</b><br>\n" if (@dirs);

foreach $dir (@dirs)	{
	my($sdir) = uri_escape($dir);
	print "<a href=\"?subdir=$sreldir$sdir\%2F\">$dir/</a><br>\n";
}

print "<br>\n" if (@dirs);

my %letters = ();
for (my $i=ord('A'); $i<=ord('Z'); $i++)	{
	$letters{chr($i)} = 0;
}

my(@files) = $f->list_dir($path, "--files-only", "--ignore-case");
for (my $i=0; $i<@files; $i++)	{
	if ($files[$i] !~ /\.(?:mp3|m3u|aac|pls)$/i)	{
		splice(@files,$i,1);
		$i--;
	}
}
my($file);

print "<b>Media Files :</b><br>\n" if (@files);
print "<b>No media files or folders found.</b><br>\n" if ((!@files) && (!@dirs));

foreach $file (@files)	{

	my $letter = uc(substr($file,0,1));
	if ((exists $letters{$letter}) and (! $letters{$letter}))	{
		print "<a name=\"$letter\"></a>";
		$letters{$letter} = 1;
	}

	if ($file =~ /\.m3u$/i)	{
		my($sfile) = "?subdir=$sreldir&m3u=".uri_escape($file);
		print "<a href=\"$sfile\">[Playlist] $file</a><br>\n";
	}
	elsif ($file =~ /\.pls$/i)	{
		my($sfile) = "$remdir$reldir$file";
		$sfile = uri_escape($sfile,"^A-Za-z0-9\-_.!~*():/");
		print "<a href=\"javascript:parent.tune(\'$sfile\',0);\">[Playlist Stream] $file</a><br>\n";
	}
	else	{
		my($sfile) = "$remdir$reldir$file";
		$sfile = uri_escape($sfile,"^A-Za-z0-9\-_.!~*():/");
		print "<a href=\"javascript:parent.tune(\'$sfile\',1);\">$file</a><br>\n";
	}
	
}

print "<script>\n";

for (my $i=ord('A'); $i<=ord('Z'); $i++)	{
	if (! $letters{chr($i)})	{
		print "document.getElementById(\"a".chr($i)."\").firstChild.nodeValue=\"\";\n";
		print "document.getElementById(\"s".chr($i)."\").firstChild.nodeValue=\"|".chr($i)."\";\n";
	}
}

print "</script>\n";

return;
}

##Error function for M3U not found
sub m3unotfound	{
	print "M3U file not found.<br>\n";
	die($_[0]);
	return;
}
